$IF 0

This routine is based on the INT10.BAS routine written by Erik Olsen.  
Extensively modified by James R. Davis.

Here's a routine I am having trouble with.  This demo of the routine should 
be run in the following manner:

                                NOVID command

Where "command" is the DOS command to execute.  What should happen is you will 
see the words "Shelling to do %command% now...", a moment of nothing, and then 
done.  Nothing should occur during that time on the screen.  Now the results 
that I have gotten are wierd.  Under the different versions of PB3, I tried 
compiling this program.  Now when I compiled this routine in PB v3.0b, If a 
DIR is issued and the directory contains more files then can fit on the screen 
at one time, then on row 1 starting poast column 40 the last line will be 
displayed.  But when I compiled it using PB v3.0c, I had "DIR" hard coded in 
the routine as the DOS command and I would get an error 76 and the routine 
wouldn't run at all!  

I've commented all the source here so you shouldn't have any problem in 
following it... but if you were to find the problem and get the routine to run 
properly, please contact me on the Programmer's Mega-Source BBS at 
516-737-4637.  Thanks!

                              -=> The Garf! <=-

$ENDIF

C$ = COMMAND$                           ' Grab the command line for DOS cmd
PRINT "Shelling to do "; C$; " now..."; ' Print our notice to user.
CALL ShellNoVid(C$)                     ' Call our routine
PRINT "Done!"                           ' Tell them we're finished.
                                        
'ShellNoVid() is a routine that will shell out to DOS without displaying 
'anything on the screen no matter what command you issue!  This comes in handy 
'when writing a program that shells out to use PKZIP or SCAN and you don't want 
'the user to know what is happening or you don't want the data that those 
'programs display messing up your display at all.
 
SUB ShellNoVid(S$)                      ' Here's our routine
  SG&  = CODESEG(INT10)                 ' Grab new seg pointer to INT10
  PR&  = CODEPTR(INT10)                 ' Grab new code pointer to INT10
                                         
  REG 1, 13584                          ' Call func 35 to get current INT10 loc
  CALL INTERRUPT &H21                   ' Call INT21
  OSG& = REG(9)                         ' Grab old seg pntr
  OPR& = REG(2)                         ' Grab old code pntr
                                        
  REG 1, 9488                           ' Call func 25 to put new INT10 loc
  REG 4, PR&                            ' Set code pntr
  REG 8, SG&                            ' Set seg pntr
  CALL INTERRUPT &H21                   ' Call INT21 - All video output should
                                        ' be disabled at this point

  SHELL S$                              ' Shell out and do command

  REG 1, 9488                           ' Call func 25 to put old INT10 loc
  REG 4, OPR&                           ' Set old code pntr
  REG 8, OSG&                           ' Set old seg pntr
  CALL INTERRUPT &H21                   ' Call INT21 - Video is turn back on
  EXIT SUB                              ' Exit this routine

INT10:                                  ' Here's the new INT10 routine
!   iret                                ; All it does it return back to prg

END SUB

